<?php
include_once ("dap-config.php");
include 'isdk.php';

foreach ($_POST as $key => $value) {
	$value = urlencode(stripslashes($value));
	$req .= "&$key=$value";
	logToFile("dap-infusionsoft: " . $key . "=" . $value, LOG_DEBUG_DAP);
}

logToFile($req);

$myApp = new iSDK;
if ($myApp->cfgCon("demo")) {
	logToFile("dap-infusionsoft: Connected...", LOG_DEBUG_DAP);
 } else {
	logToFile("dap-infusionsoft: Failed to connect to Infusionsoft!");
	return;
}

// get contact ID
// Use contactId to get invoice ID from invoice table
// Use Invoice Id to get purchased InvoiceItemId(s) from invoice item
// Use the InvoiceItemId(s) to get the purchased product Id from orderitem table
// Use the product Id to get product details from product

$contactId = $_POST["Id"];
if ($contactId == '') {
	logToFile("dap-infusionsoft: missing contactId in POST params", LOG_DEBUG_DAP);
	return;
}

$ownerId = $_POST["OwnerID"];

$post = array();
$post = $_POST;
					
//get shipping details
$query = array('ContactId'=>$contactId);
$returnFields = array("Id");
$cardIds = $myApp->dsQuery("CreditCard",100,0,$query,$returnFields);
$highestCardId = $cardIds[0]["Id"];
foreach ($cardIds as $key => $cardId) { 
	if ($cardId["Id"] > $highestCardId) 
		$highestCardId = $cardId["Id"];
	logToFile("dap-infusionsoft: cardIds=" . $cardId["Id"], LOG_DEBUG_DAP);				
}
logToFile("dap-infusionsoft: highestcardId=" . $highestCardId, LOG_DEBUG_DAP);				

//get shipping details
$query = array('Id'=>$highestCardId);
$returnFields = array("ShipFirstName", "ShipLastName", "ShipAddress1", "ShipCity", "ShipState", "ShipZip", "ShipCountry");
$shipDetails = $myApp->dsQuery("CreditCard",100,0,$query,$returnFields);

$post_values = array();
// set params
$post['payer_email'] = urldecode($_POST['Email']);
$post['first_name'] = urldecode($_POST['FirstName']);
$post['last_name'] = urldecode($_POST['LastName']);
$post['address1'] = urldecode($_POST['StreetAddress1']);
$post['city'] = urldecode($_POST['City']);
$post['state'] = urldecode($_POST['State']);
$post['zip'] = urldecode($_POST['PostalCode']);
$post['country'] = urldecode($_POST['Country']);
$post['phone'] = urldecode($_POST['Phone1']);
		
$post['ship_to_first_name'] = isset($shipDetails[0]['ShipFirstName']) ? urldecode($shipDetails[0]['ShipFirstName']): urldecode($_POST['FirstName']);
$post['ship_to_last_name'] = isset($shipDetails[0]['ShipLastName']) ? urldecode($shipDetails[0]['ShipLastName']): urldecode($_POST['LastName']);

$post['ship_to_address1'] = isset($shipDetails[0]['ShipAddress1']) ? urldecode($shipDetails[0]['ShipAddress1']): urldecode($_POST['StreetAddress1']);
$post['ship_to_city'] = isset($shipDetails[0]['ShipCity']) ? urldecode($shipDetails[0]['ShipCity']): urldecode($_POST['City']);
$post['ship_to_state'] = isset($shipDetails[0]['ShipState']) ? urldecode($shipDetails[0]['ShipState']): urldecode($_POST['State']);
$post['ship_to_zip'] =  isset($shipDetails[0]['ShipZip']) ? urldecode($shipDetails[0]['ShipZip']): urldecode($_POST['PostalCode']);
$post['ship_to_country'] = isset($shipDetails[0]['ShipCountry']) ? urldecode($shipDetails[0]['ShipCountry']): urldecode($_POST['Country']); 
$post['email'] = urldecode($_POST['Email']);

$query = array('ContactId'=> $contactId);
//$returnFields = array("Id", "PayStatus", "DateCreated","JobId"); // return invoice Id
$returnFields = array("Id", "PayStatus", "DateCreated", "JobId", "ProductSold"); // return invoice Id

$invoices = $myApp->dsQuery("Invoice",10,0,$query,$returnFields);
$txn_num=0;
foreach ($invoices as $key => $invoice) { 
  //check date
  $datecreated = $invoice["DateCreated"];
  $today = date("Y-m-d");
  $invoiceId = $invoice["Id"];
  $jobId=$invoice["JobId"];
  /*	
  $query = array('InvoiceId'=> $invoiceId);
  $returnFields = array("PayStatus"); // return invoice Id
  $payment = $myApp->dsQuery("InvoicePayment",10,0,$query,$returnFields);
  */
  
  $payStatus = $invoice["PayStatus"];
  
  logToFile("dap-infusionsoft: date created=" . $datecreated, LOG_DEBUG_DAP);
  logToFile("dap-infusionsoft: today=" . $today, LOG_DEBUG_DAP);
  logToFile("dap-infusionsoft: invoiceId=" . $invoiceId, LOG_DEBUG_DAP);
  logToFile("dap-infusionsoft: payStatus=" . $payStatus, LOG_DEBUG_DAP);
  logToFile("dap-infusionsoft: jobId=" . $jobId, LOG_DEBUG_DAP);
  
 /* if(greaterDate($today,$datecreated)) {
	  logToFile("dap-infusionsoft: skipping older invoice", LOG_DEBUG_DAP);
	  continue; // do not process invoice older than today
  }*/
  
  $jobId=(string) $jobId;
  usleep(9000000);
  
  $product_ids = explode(",", $invoice['ProductSold']);

  if(count($product_ids) > 1) {
	  logToFile("dap-infusionsoft: Multiple products in the cart" . $product_ids[$j], LOG_DEBUG_DAP);
  }
	
  for ($j = 0; $j < count($product_ids); $j++) {
	  logToFile("dap-infusionsoft: ONETIME:  INVOICE PRODUCT SOLD ARRAY $j, product_ids[$j]" . $product_ids[$j], LOG_DEBUG_DAP); 
  }

  for ($j = 0; $j < count($product_ids); $j++) {
      logToFile("dap-infusionsoft: INVOICE PRODUCT SOLD ARRAY $j, product_ids[$j]" . $product_ids[$j], LOG_DEBUG_DAP);
      
	  if(count($product_ids) > 1) 
	    $product_id = $product_ids[$j];
	  else
	    $product_id = array_shift($product_ids);
		
	  if ($product_id != '') {
		$query = array('Id' => $product_id);
		$returnFields = array("ProductName","ProductPrice");
		$productdetails = $myApp->dsQuery("Product", 1, 0, $query, $returnFields);
		$productName = urldecode($productdetails[0]["ProductName"]);
		sendAdminEmail("DAP InfusionSoft: ACCENTED CHAR TEST:  INFUSIONSOFT SENT THIS PRODUCT NAME =".$productName, "DAP InfusionSoft: ACCENTED CHAR TEST:  INFUSIONSOFT SENT THIS PRODUCT NAME =".$productName);
		logToFile("dap-infusionsoft: PRODUCT NAME = " . $productName, LOG_DEBUG_DAP);
		 
		$amt=urldecode($productdetails[0]["ProductPrice"]);
		$post['item_name'] = urldecode($productName);
		$post['item_number'] = urldecode($product_id);
	  
		// complex logic because by default the recurring charges are not complete at the time the post arrives
		if (trim($payStatus) != "1") {
		  logToFile("dap-infusionsoft: force charge the invoice Id=" . $invoiceId, LOG_DEBUG_DAP);
		  logToFile("dap-infusionsoft: creditcardId = " . $highestCardId, LOG_DEBUG_DAP);
		  $result = $myApp->chargeInvoice($invoiceId,"Customer Paid",intval($highestCardId),2,false);
		  logToFile("dap-infusionsoft: here's the result of force charge = " . $result, LOG_DEBUG_DAP);
				  
		  if ( (stristr($result,"DECLINED") == FALSE) && (stristr($result,"ERROR") == FALSE) ) {
			logToFile("dap-infusionsoft: payment approved for the recurring program", LOG_DEBUG_DAP);	
		  }
		  else {
			logToFile("dap-infusionsoft: payment not approved for contactID = " . $contactId);
			sendAdminEmail("dap-infusionsoft: payment not approved for contactID = " . $contactId . ", invoiceId = " . $invoiceId,"dap-infusionsoft: payment not approved for contactID = " . $contactId . ", invoiceId = " . $invoiceId);
			continue;
		  }
		}
	  }
	  else {
	   logToFile("dap-infusionsoft:productId missing under ProductSold in the Invoice table");
	   sendAdminEmail("dap-infusionsoft: productId missing under ProductSold","dap-infusionsoft: productId missing under ProductSold in the Invoice table for contactID = " . $contactId . ", invoiceId = " . $invoiceId);
	   continue;
	  }
		  
	  $post['mc_gross'] = $amt;
	  $post['mc_currency'] = "USD";
	
	  if(!isset($post['mc_gross'])) { 
		  $post['mc_gross'] = '0.00';
	  }
	  if(!isset($post['payment_status'])) { 
		  $post['payment_status'] = 'Completed';
	  }
	  
	  $post['txn_type']= "subscr_payment";
	  $post['txn_id'] = urldecode($_POST["Id"]) . ":" . urldecode($invoiceItemId) . ":" . $txn_num; 
	  
	  $record_id = Dap_PaymentProcessor::recordInfusionSoftIncoming($post);
	  logToFile("dap-infusionsoft.php: recorded incoming infusionsoft id:". $record_id);
	  if ($record_id != -1) {
		  Dap_Transactions::setRecordStatus($record_id, 1);
		  logToFile("dap-infusionsoft.php:setRecordStatus(): set record status to 1 for record_id=". $record_id);
		  //finally process the transaction
		  Dap_Transactions::processTransaction($record_id);
	  }
		  
	  $txn_num++;
	  if(count($product_ids) == 1) {
		  logToFile("dap-infusionsoft.php:ONLY 1 PRODUCT IN LIST". $record_id);
		  break;
	  }
  } //end for
}

logToFile("dap-infusionsoft: EXITING...");

function greaterDate($start_date,$end_date)
{
  $start = strtotime($start_date);
  $end = strtotime($end_date);
  if ($start-$end > 0)
    return 1;
  else
   return 0;
}

?>
